#define _CRT_SECURE_NO_WARNINGS
#include "Automobile.h"

Automobile::Automobile(
    const char* p_surname_of_owner,
    const char* p_car_make_code,
    const char* p_car_make,
    const char* p_required_mark_of_fuel,
    double p_engine_power,
    double p_tank_volume,
    double p_fuel_remainig,
    double p_oil_volume,
    double p_fuel_price,
    double p_oil_price)
    : engine_power(p_engine_power)
    , tank_volume(p_tank_volume)
    , fuel_remainig(p_fuel_remainig)
    , oil_volume(p_oil_volume)
    , fuel_price(p_fuel_price)
    , oil_price(p_oil_price)
{
    strcpy(surname_of_owner, p_surname_of_owner);
    strcpy(car_make_code, p_car_make_code);
    strcpy(car_make, p_car_make);
    strcpy(required_mark_of_fuel, p_required_mark_of_fuel);
}


 Automobile::Automobile(const Automobile& car)
     : engine_power(car.engine_power)
     , tank_volume(car.tank_volume)
     , fuel_remainig(car.fuel_remainig)
     , oil_volume(car.oil_volume)
     , fuel_price(car.fuel_price)
     , oil_price(car.oil_price)
 {
     strcpy(surname_of_owner, car.surname_of_owner);
     strcpy(car_make_code, car.car_make_code);
     strcpy(car_make, car.car_make);
     strcpy(required_mark_of_fuel, car.required_mark_of_fuel);
 }

 Automobile& Automobile::operator=(const Automobile& car) {
    if (this != &car) {
        strcpy(surname_of_owner, car.surname_of_owner);
        strcpy(car_make_code, car.car_make_code);
        strcpy(car_make, car.car_make);
        strcpy(required_mark_of_fuel, car.required_mark_of_fuel);
 
        engine_power = car.engine_power;
        tank_volume =  car.tank_volume;
        fuel_remainig = car.fuel_remainig;
        oil_volume = car.oil_volume;
        fuel_price = car.fuel_price;
        oil_price = car.oil_price;
    }
     return *this;
 }
 

std::istream& operator>>(std::istream& p_in, Automobile& p_car) {
    p_in >> p_car.surname_of_owner
         >> p_car.car_make_code
         >> p_car.car_make
         >> p_car.required_mark_of_fuel
         >> p_car.engine_power
         >> p_car.tank_volume
         >> p_car.fuel_remainig
         >> p_car.oil_volume
         >> p_car.fuel_price
         >> p_car.oil_price;
    return p_in;
}


std::ostream& operator<<(std::ostream& p_out, const Automobile& p_auto) {
    p_out << p_auto.surname_of_owner << std::endl
          << p_auto.car_make_code << std::endl
          << p_auto.car_make << std::endl
          << p_auto.required_mark_of_fuel << std::endl
          << p_auto.engine_power << std::endl
          << p_auto.tank_volume << std::endl
          << p_auto.fuel_price << std::endl
          << p_auto.oil_price << std::endl;
    return p_out;
}

